(function() {

    tinymce.PluginManager.add('bpshortcodes', function( editor )
    {
        var shortcodeValues = [];
        jQuery.each(shortcodes_button, function(i)
        {
            shortcodeValues.push({text: shortcodes_button[i], value:i});
        });

        editor.addButton('bpshortcodes', {
            type: 'listbox',
            text: 'Shortcodes',
            onselect: function(e) {
                var v = e.control._text;
                var c = tinyMCE.activeEditor.selection.getContent();

                //How to make this more dynamic as a plugin?
                if(v == 'button') {
                    tinyMCE.activeEditor.selection.setContent('[' + v + ' link="http://Enter Link Here" title="Button"]' + tinyMCE.activeEditor.selection.getContent() + '[/' + v + ']');
                } else if(c == '') {
                    tinyMCE.activeEditor.selection.setContent('[' + v + '/]');
                } else {
                    tinyMCE.activeEditor.selection.setContent('[' + v + ']' + tinyMCE.activeEditor.selection.getContent() + '[/' + v + ']');
                }
            },
            values: shortcodeValues
        });
    });
})();